/*
 *  TOPPERS/A-CAN
 *      Automotive CAN
 *
 *  Copyright (C) 2013-2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2013-2014 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2013-2014 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2013-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2013-2014 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2013-2014 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2013-2014 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: Can.c 4208 2014-03-13 04:05:21Z shigihara $
 */

/* [CAN034] */
#include "Os.h"
#include "ComStack_Types.h"
#include "Can.h"
#include "CanIf_Cbk.h"

/* SchM_Can.hRTEͥ졼ˤ */
#include "SchM_Can.h"

#include "Can_Nios2.h"

#define MAX_DLC			8
#define BYTE_LENGTH		4

/*
 *  ߼¹CanIfե졼
 */
const Can_ConfigType		*p_cur_can_config;
const Can_HwHandleType		*p_cur_hoh_box_table;
const Can_HwHandleType		*p_cur_rbox_hrh_table;
const Can_IdType			*p_cur_rbox_filter_table;
PduIdType					*p_cur_saved_pduid;
const CAN_CTRL_INIB			*p_cur_can_ctrl_inib_table;

/* ǥեȤCanIfե졼 */
extern const Can_ConfigType	can_config[];

/*
 *  [CAN223] Can_Init
 */
void
Can_Init(const Can_ConfigType *Config)
{
	Can_HwHandleType	i;
	uint32				can_id_reg;
	const CAN_CTRL_INIB	*p_ctrl_cb;

	if (Config == NULL_PTR) {
		/* NULL_PTRξ硤ƬΥե졼Ѥ */
		Config = &can_config[0];
	}

	/* ߼¹Υե졼ݻ */
	p_cur_can_config = Config;
	p_cur_hoh_box_table = Config->p_hoh_box_table;
	p_cur_rbox_hrh_table = Config->p_rbox_hrh_table;
	p_cur_rbox_filter_table = Config->p_rbox_filter_table;
	p_cur_saved_pduid = Config->p_saved_pduid;
	p_cur_can_ctrl_inib_table = Config->p_can_ctrl_inib_table;

	p_ctrl_cb = GET_CAN_CTRL_INIB(0);

	/* ȥ߾֤ǽ */
	CANC_WR_MODE_REG(CANC_MODE_STOP);

	/* ǥեȥܡ졼Ȥꤹ */
	Can_ChangeBaudrate(0U, p_ctrl_cb->default_baudrate);

	/* ߵ */
	CANC_WR_IRQ_EN_REG(IRQ_SET_ENABLE);

	/* ץ󥹥ե륿 */
	/* ΤΥץ󥹥ɥ쥸(Ƶ) */
	CANC_WR_ACCEPTANCE_CODE_REG(0xFFFFFFFFU);

	/* ΤΥץ󥹥ޥ쥸(Ƶ) */
	CANC_WR_ACCEPTANCE_MASK_REG(0xFFFFFFFFU);

	/* åܥåɥ쥸Ǥ줾ΥܥåФƥե륿ꤹ */
	for (i = 0U; i < GET_HRH_NUM(); i++) {
		/* оݤꤹ */
		CANC_WR_MBOXWIN_REG(i);

		/* ƼåܥåΥץ󥹥ɥ쥸 */
		can_id_reg = ((uint32) GET_RBOX_CAN_ID_FILTER(i)) << ACCEPTANCE_OFFSET;
		CANC_WR_RXMBOX_ACCEPTANCE_CODE_REG(can_id_reg);

		/* ƼåܥåΥץ󥹥ޥ쥸 */
		CANC_WR_RXMBOX_ACCEPTANCE_MASK_REG(ACCEPTANCE_MASK);
	}

	/* 쥸ν */
	/* ̤Υå򥭥󥻥뤹 */
	CANC_WR_TXABORT_REG(TXABORT_CLEAR);

	/* 顼󥿥쥸ͤ(Ȥͤ0̵硢顼󥿤ѹԲ) */
	CANC_WR_ERROR_CNT_REG(ERROR_CNT_CLEAR);

	/* ׵쥸׵̵ˤ */
	CANC_WR_RXSELFREQ_REG(RXSELFREQ_CLEAR);

	/* ȥ쥸򥦥Ƚդˤ */
	CANC_WR_RXWAIT_REG(RXWAIT_OFF);

	/* λ쥸̤λˤ */
	CANC_WR_TXCMP_REG(TXCMP_CLEAR);

	/* 󥻥봰λ쥸󥻥̤λˤ */
	CANC_WR_TXABORTCMP_REG(TXABORTCMP_CLEAR);

	/* λ쥸ǡ̵ˤ */
	CANC_WR_RXCMP_REG(RXCMP_CLEAR);

	/* С饤ȥ쥸̤ȯˤ */
	CANC_RD_RXOVERWRITE_REG();

	/* ߵĥ쥸ߵĤˤ */
	CANC_WR_IRQ_RXEN_REG(IRQ_RXEN_PERMIT);

	/* ׵쥸̤ȯˤ */
	/* read뤳Ȥǡͤ(̤ȯ)˥ꥻåȤ */
	CANC_RD_IRQ_REG();
}

/*
 *  [CAN224] Can_GetVersionInfo
 */
/* [CAN252] */
#if CAN_VERSION_INFO_API == STD_ON
void
Can_GetVersionInfo(Std_VersionInfoType *versioninfo)
{
	versioninfo->vendorID = CAN_VENDOR_ID;
	versioninfo->moduleID = CAN_MODULE_ID;
	versioninfo->sw_major_version = CAN_SW_MAJOR_VERSION;
	versioninfo->sw_minor_version = CAN_SW_MINOR_VERSION;
	versioninfo->sw_patch_version = CAN_SW_PATCH_VERSION;
}
#endif /* CAN_VERSION_INFO_API */

/*
 *  [CAN454][CAN455] Can_CheckBaudrate
 */
Std_ReturnType
Can_CheckBaudrate(uint8 Controller, const uint16 Baudrate)
{
	uint8				i;
	Std_ReturnType		ercd = E_NOT_OK;
	const CAN_CTRL_INIB	*p_ctrl_cb;

	/* ȥ1ĤΤ */
	if (Controller >= TNUM_CONTROLLER) {
		goto error_exit;
	}

	p_ctrl_cb = GET_CAN_CTRL_INIB(Controller);

	for (i = 0U; i < p_ctrl_cb->tnum_baudrate; i++) {
		if (p_ctrl_cb->p_baudrate_table[i] == Baudrate) {
			ercd = E_OK;
			break;
		}
	}

  error_exit:
	return(ercd);
}

/*
 *  [CAN449] Can_ChangeBaudrate
 */
Std_ReturnType
Can_ChangeBaudrate(uint8 Controller, const uint16 Baudrate)
{
	Std_ReturnType ercd;

	ercd = Can_CheckBaudrate(Controller, Baudrate);

	/* E_OKξ硤250500ʤ */
	if (ercd == E_OK) {
		if (Baudrate == 250U) {
			CANC_WR_CLKDIV_BUSTIM_REG(BAUDRATE_250);
		}
		else {
			/* Baudrate == 500U */
			CANC_WR_CLKDIV_BUSTIM_REG(BAUDRATE_500);
		}
	}

  error_exit:
	return(ercd);
}

/*
 *  [CAN230] Can_SetControllerMode
 */
Can_ReturnType
Can_SetControllerMode(uint8 Controller, Can_StateTransitionType Transition)
{
	Can_ReturnType		ercd;
	const CAN_CTRL_INIB	*p_ctrl_cb;

	/* ȥ1ĤΤ */
	if (Controller >= TNUM_CONTROLLER) {
		ercd = CAN_NOT_OK;
		goto error_exit;
	}

	p_ctrl_cb = GET_CAN_CTRL_INIB(Controller);

	if (Transition == CAN_T_START) {
		CANC_WR_MODE_REG(CANC_MODE_START);
		CanIf_ControllerModeIndication(p_ctrl_cb->CanIfCtrlId, CANIF_CS_STARTED);
		ercd = CAN_OK;
	}
	else if (Transition == CAN_T_STOP) {
		CANC_WR_MODE_REG(CANC_MODE_STOP);
		CanIf_ControllerModeIndication(p_ctrl_cb->CanIfCtrlId, CANIF_CS_STOPPED);
		ercd = CAN_OK;
	}
	else {
		ercd = CAN_NOT_OK;
	}

  error_exit:
	return(ercd);
}

/*
 *  [CAN360] Can_CheckWakeup
 */
Can_ReturnType
Can_CheckWakeup(uint8 Controller)
{
	/* åפ̤ݡ */
	return(CAN_OK);
}

/*
 *  [CAN233] Can_Write
 */
Can_ReturnType
Can_Write(Can_HwHandleType Hth, const Can_PduType *PduInfo)
{
	Can_ReturnType	ercd;
	uint8			i, j;
	uint32			temp_data1 = 0;         /* ǡ(14byte)Ǽ */
	uint32			temp_data2 = 0;         /* ǡ(58byte)Ǽ */
	uint32			request_bit;
	uint8			tbox;

	/* Hthξ */
	if (Hth >= GET_HOH_NUM()) {
		ercd = CAN_NOT_OK;
		goto error_exit;
	}

	tbox = GET_BOX_ID(Hth);

	/* HthIDξ(ɤ¸ߤIDξϥåʤ) */
	if (tbox >= GET_HTH_NUM()) {
		ercd = CAN_NOT_OK;
		goto error_exit;
	}

	/* λѤPDU-IDݻ */
	GET_SAVED_PDU_ID(tbox) = PduInfo->swPduHandle;

	/* åΥǡ5byteʾʤ顢5byteܰʹߤ˼ */
	if (PduInfo->length > BYTE_LENGTH) {
		/* 58byteΥǡ򥳥ԡ */
		for (i = 0U; i < (PduInfo->length - BYTE_LENGTH); i++) {
			if (i > 0U) {
				temp_data2 = temp_data2 << 8U;
			}
			temp_data2 = (temp_data2 | PduInfo->sdu[PduInfo->length - (1U + i)]);
		}
	}
	else {
		i = 0U;
	}

	/* åΥǡ1byteʾʤ顢1byteܰʹߤ */
	if (PduInfo->length > 0) {
		/* 14byteΥǡ򥳥ԡ */
		for (j = i; j < PduInfo->length; j++) {
			if (j > i) {
				temp_data1 = temp_data1 << 8U;
			}
			temp_data1 = (temp_data1 | PduInfo->sdu[PduInfo->length - (1U + j)]);
		}
	}

	/* CAN-IDγǼ */
	CANC_WR_TXMBOX_DATA0_REG((PduInfo->id << EXTEND_CAN_ID_LENGTH), tbox);

	/* ǡĹγǼ */
	CANC_WR_TXMBOX_DATA1_REG(PduInfo->length, tbox);

	if (PduInfo->length > 0) {
		/* ǡ(14)γǼ */
		CANC_WR_TXMBOX_DATA2_REG(temp_data1, tbox);
	}
	/* ǡ5byteʾʤǼ */
	if (PduInfo->length > BYTE_LENGTH) {
		/* ǡ(58)γǼ */
		CANC_WR_TXMBOX_DATA3_REG(temp_data2, tbox);
	}

	SuspendAllInterrupts();

	request_bit = 1U << tbox;
	CANC_WR_TXREQ_REG(request_bit);

	ResumeAllInterrupts();

  error_exit:
	return(ercd);
}

/*
 *  [CAN035] CANѳߥӥ롼
 */
void
Can_ISR(uint8 Controller)
{
	Can_HwHandleType	i;
	uint8				j;
	uint32				irq_reg;
	uint32				clear_bit;
	uint32				cmp_reg;
	uint32				wait_reg;
	Can_IdType			can_id;
	uint8				can_dlc;
	uint8				can_sdu[MAX_DLC];
	uint32				temp_data;

	/* ȥ1ĤΤ */
	if (Controller >= TNUM_CONTROLLER) {
		goto error_exit;
	}

	irq_reg = CANC_RD_IRQ_REG();

	/* λ */
	if ((irq_reg & RECEIVE_IRQ) != 0U) {
		clear_bit = 1U;
		cmp_reg = CANC_RD_RXCMP_REG();

		if (cmp_reg != 0U) {
			for (i = 0U; i < GET_HRH_NUM(); i++) {
				if ((cmp_reg & 1U) != 0U) {

					/* оݼȥ쥸γӥåȤ򥦥ȽONˤ */
					wait_reg = CANC_RD_RXWAIT_REG();
					wait_reg |= clear_bit;
					CANC_WR_RXWAIT_REG(wait_reg);

					/* CAN-IDФ */
					can_id = ((CANC_RD_RXMBOX_DATA0_REG(i) & MASK_CAN_ID_MASK) >> EXTEND_CAN_ID_LENGTH);

					/* DLCμФ */
					can_dlc = (uint8) (CANC_RD_RXMBOX_DATA1_REG(i) & MASK_4BIT);

					if (can_dlc > BYTE_LENGTH) {
						/* 5byteʾξ硢5byteܰʹߤΥ쥸ɤ߹ */
						/* SDU(14byte)μФ */
						temp_data = CANC_RD_RXMBOX_DATA2_REG(i);
						for (j = 0U; j < BYTE_LENGTH; j++) {
							can_sdu[j] = (uint8) (temp_data & MASK_8BIT);
							temp_data >>= 8U;
						}
						/* SDU(58byte)μФ */
						temp_data = CANC_RD_RXMBOX_DATA3_REG(i);
						for (j = BYTE_LENGTH; j < can_dlc; j++) {
							can_sdu[j] = (uint8) (temp_data & MASK_8BIT);
							temp_data >>= 8U;
						}
					}
					else {
						/* 4byteʲξ硢5byteܰʹߤΥ쥸ɤ߹ޤʤ */
						/* SDU(14byte)μФ */
						temp_data = CANC_RD_RXMBOX_DATA2_REG(i);
						for (j = 0U; j < can_dlc; j++) {
							can_sdu[j] = (uint8) (temp_data & MASK_8BIT);
							temp_data >>= 8U;
						}
					}

					CANC_WR_RXCMP_REG(clear_bit);

					/* оݼȥ쥸γӥåȤ򥦥ȽOFFˤ */
					wait_reg = wait_reg ^ clear_bit;
					CANC_WR_RXWAIT_REG(wait_reg);

					CanIf_RxIndication(GET_RBOX_CAN_OBJ_ID(i), can_id, can_dlc, can_sdu);
				}
				cmp_reg >>= 1U;
				clear_bit <<= 1U;
			}
		}
	}

	/* λ */
	if ((irq_reg & TRANSMIT_IRQ) != 0U) {
		clear_bit = 1U;
		cmp_reg = CANC_RD_TXCMP_REG();

		if (cmp_reg != 0U) {
			for (i = 0U; i < GET_HTH_NUM(); i++) {
				if ((cmp_reg & 1U) != 0U) {
					CANC_WR_TXCMP_REG(clear_bit);
					CanIf_TxConfirmation(GET_SAVED_PDU_ID(i));
				}
				cmp_reg >>= 1U;
				clear_bit <<= 1U;
			}
		}
	}

  error_exit:
	return;
}
