/*
 *  TOPPERS/A-CAN
 *      Automotive CAN
 *
 *  Copyright (C) 2013-2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2013-2014 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2013-2014 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2013-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2013-2014 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2013-2014 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2013-2014 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: Can.h 4208 2014-03-13 04:05:21Z shigihara $
 */

#ifndef CAN_H
#define CAN_H

/* [CAN034][CAN435][CAN388] */
#include "ComStack_Types.h"
#include "Can_GeneralTypes.h"
#include "Can_Cfg.h"

#define CAN_MODULE_ID	80U

/*
 *  AUTOSAR꡼С
 */
#define CAN_AR_RELEASE_MAJOR_VERSION		4U
#define CAN_AR_RELEASE_MINOR_VERSION		0U
#define CAN_AR_RELEASE_REVISION_VERSION		3U

/*
 *  ץ饤С
 */
#define CAN_SW_MAJOR_VERSION	1U
#define CAN_SW_MINOR_VERSION	0U
#define CAN_SW_PATCH_VERSION	0U
#define CAN_VENDOR_ID			65U /* NCES٥ID */

/*
 *  ޥ
 */
#define GET_HOH_NUM()					p_cur_can_config->tnum_hoh
#define GET_HTH_NUM()					p_cur_can_config->tnum_hth
#define GET_HRH_NUM()					p_cur_can_config->tnum_hrh
#define GET_BOX_ID(hoh)					p_cur_hoh_box_table[(hoh)]
#define GET_RBOX_CAN_OBJ_ID(rbox)		p_cur_rbox_hrh_table[(rbox)]
#define GET_RBOX_CAN_ID_FILTER(rbox)	p_cur_rbox_filter_table[(rbox)]
#define GET_SAVED_PDU_ID(tbox)			p_cur_saved_pduid[(tbox)]
#define GET_CAN_CTRL_INIB(id)			&p_cur_can_ctrl_inib_table[(id)]


/* [CAN043][CAN037] ܥեˤϡCanΥƥॵӥѿexternǡΤߤ򵭽Ҥ */

typedef struct can_controller_initialization_block {
	uint8			CanIfCtrlId;        /* CanIf¦ΥȥID */
	uint8			tnum_baudrate;      /* ǽʥܡ졼ȿ */
	uint16			default_baudrate;   /* ǥեȥܡ졼 */
	const uint16	*p_baudrate_table;  /* ݡȥܡ졼ȥꥹ */
} CAN_CTRL_INIB;

/*
 *  [CAN413] Canե졼֥å
 */
typedef struct can_config_type {
	Can_HwHandleType		tnum_hoh;               /* HOH */
	Can_HwHandleType		tnum_hth;               /* HTH */
	Can_HwHandleType		tnum_hrh;               /* HRH */
	const Can_HwHandleType	*p_hoh_box_table;       /* HOHܥåֹѴơ֥ */
	const Can_HwHandleType	*p_rbox_hrh_table;      /* ܥåֹ梪HRHѴơ֥ */
	const Can_IdType		*p_rbox_filter_table;   /* ܥåե륿ơ֥(FullCanǤCAN-IDȰפ) */
	PduIdType				*p_saved_pduid;         /* λPDU-ID¸Хåե */
	const CAN_CTRL_INIB		*p_can_ctrl_inib_table; /* ȥ֥åơ֥ */
} Can_ConfigType;

extern void Can_Init(const Can_ConfigType *Config);
extern void Can_GetVersionInfo(Std_VersionInfoType *versioninfo);
extern Std_ReturnType Can_CheckBaudrate(uint8 Controller, const uint16 Baudrate);
extern Std_ReturnType Can_ChangeBaudrate(uint8 Controller, const uint16 Baudrate);
extern Can_ReturnType Can_SetControllerMode(uint8 Controller, Can_StateTransitionType Transition);
extern Can_ReturnType Can_CheckWakeup(uint8 Controller);
extern Can_ReturnType Can_Write(Can_HwHandleType Hth, const Can_PduType *PduInfo);
extern void Can_ISR(uint8 Controller);

extern const CAN_CTRL_INIB can_ctrl_inib_table[];

#endif /* CAN_H */
