/*
 *  TOPPERS/A-CAN
 *      Automotive CAN
 *
 *  Copyright (C) 2013-2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2013-2014 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2013-2014 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2013-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2013-2014 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2013-2014 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2013-2014 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: Can_Nios2.h 4208 2014-03-13 04:05:21Z shigihara $
 */

#ifndef CAN_NIOS2_H
#define CAN_NIOS2_H

#include "prc_sil.h"

#define CANC_0_BASE		0x08020000U    /* CANȥ0Υ١ɥ쥹 */

#define EXTEND_CAN_ID_LENGTH	18U             /* ĥʬCAN-ID */
#define ACCEPTANCE_OFFSET		21U             /* ץ󥹥ɥ쥸Υեå */
#define ACCEPTANCE_MASK			0x001FFFFFU     /* ץ󥹥ޥ쥸ꤹޥ */

/* ⡼ɥ쥸 */
#define RESET_MODE			0x00000001U                                                                 /* ư⡼ɤRESET_MODEˤ */
#define OPERATING_MODE		0x00000000U                                                                 /* ư⡼ɤOPERATING_MODEˤ */
#define LISTEN_ONLY_MODE	0x00000002U                                                                 /* ػ */
#define NO_LISTEN_ONLY_MODE	0x00000000U                                                                 /*  */
#define NO_SEND_ACK_MODE	0x00000004U                                                                 /* ACKػ */
#define SEND_ACK_MODE		0x00000000U                                                                 /* ACK */
#define SINGLE_FILTER_MODE	0x00000008U                                                                 /* Single filter mode */
#define DUAL_FILTER_MODE	0x00000000U                                                                 /* Dual filter mode */
#define CANC_MODE_START		(OPERATING_MODE | NO_LISTEN_ONLY_MODE | SEND_ACK_MODE | SINGLE_FILTER_MODE) /* CANȥSTART */
#define CANC_MODE_STOP		(RESET_MODE     | NO_LISTEN_ONLY_MODE | SEND_ACK_MODE | SINGLE_FILTER_MODE) /* CANȥSTOP */

/* ׵ */
#define RECEIVE_IRQ			0x00000001U     /* λ */
#define TRANSMIT_IRQ		0x00000002U     /* λ */

#define IRQ_SET_DISABLE		0x00000000U     /* [ߵĥ쥸]׵ػ */
#define IRQ_SET_ENABLE		0x000000FFU     /* [ߵĥ쥸]γ׵ */
#define TXABORT_CLEAR		0x0000FFFFU     /* [󥻥쥸]åܥå󥻥 */
#define TXCMP_CLEAR			0x0000FFFFU     /* [λ쥸]λӥåȥꥢ */
#define TXABORTCMP_CLEAR	0x0000FFFFU     /* [󥻥봰λ쥸]󥻥봰λӥåȥꥢ */
#define RXWAIT_OFF			0x00000000U     /* [ȥ쥸]ȽOFF */
#define RXCMP_CLEAR			0xFFFFFFFFU     /* [λ쥸]λӥåȥꥢ */
#define RXSELFREQ_CLEAR		0x00000000U     /* [ռ׵쥸]׵ʤ */
#define ERROR_CNT_CLEAR		0x00000060U     /* [顼󥿥쥸]顼󥿤ͤˤ */
#define BAUDRATE_250		0x80007F03U     /* [å桤Хߥ󥰥쥸]ܡ졼:250kbps */
#define BAUDRATE_500		0x80007F01U     /* [å桤Хߥ󥰥쥸]ܡ졼:500kbps */
#define IRQ_RXEN_PERMIT		0xFFFFFFFFU     /* [ߵĥ쥸]ߵ */

#define MASK_CAN_ID_MASK	0x1FFFFFFFU     /* CanIdޥ */
#define MASK_4BIT			0x0000000FU     /* 4ӥåȥޥ */
#define MASK_8BIT			0x000000FFU     /* 8ӥåȥޥ */

/*  */
/* ƥ쥸ޤǤΥեåȥɥ쥹 */
#define CANC_MODE_REG							0x0000U     /* ⡼ */
#define CANC_TXREQ_REG							0x0004U
#define CANC_TXABORT_REG						0x0008U     /* 󥻥쥸 */
#define CANC_TXCMP_REG							0x000CU
#define CANC_TXABORTCMP_REG						0x0010U
#define CANC_RXWAIT_REG							0x0014U
#define CANC_RXCMP_REG							0x0018U
#define CANC_RXOVERWRITE_REG					0x001CU
#define CANC_RXSELFREQ_REG						0x0020U
#define CANC_STATUS_REG							0x0024U
#define CANC_IRQ_REG							0x0028U
#define CANC_IRQ_EN_REG							0x002CU     /* ߵĥ쥸 */
#define CANC_IRQ_RXEN_REG						0x0030U
#define CANC_CLKDIV_BUSTIM_REG					0x0034U     /* å桤Хߥ */
#define CANC_ACCEPTANCE_CODE_REG				0x0038U     /* ץ󥹥ɥ쥸 */
#define CANC_ACCEPTANCE_MASK_REG				0x003CU     /* ץ󥹥ޥ쥸 */
#define CANC_ARBITRATION_LOST_CAPTURE_REG		0x0040U
#define CANC_ERROR_CAPTURE_CODE_REG				0x0044U
#define CANC_ERROR_CNT_REG						0x0048U
#define CANC_MBOXWIN_REG						0x004CU     /* åܥåɥ쥸 */
#define CANC_RXMBOX_ACCEPTANCE_CODE_REG			0x0070U     /* åܥåΥץ󥹥ɥ쥸 */
#define CANC_RXMBOX_ACCEPTANCE_MASK_REG			0x0074U     /* åܥåΥץ󥹥ޥ쥸 */
#define CANC_TXMBOX_DATA0_REG					0x0100U
#define CANC_TXMBOX_DATA1_REG					0x0104U
#define CANC_TXMBOX_DATA2_REG					0x0108U
#define CANC_TXMBOX_DATA3_REG					0x010CU
#define CANC_RXMBOX_DATA0_REG					0x0200U
#define CANC_RXMBOX_DATA1_REG					0x0204U
#define CANC_RXMBOX_DATA2_REG					0x0208U
#define CANC_RXMBOX_DATA3_REG					0x020CU

#define SIL_REW_IOP_CANC_0_BASE(mem)		sil_rew_iop((void *) (CANC_0_BASE + (mem)))
#define SIL_WRW_IOP_CANC_0_BASE(mem, data)	sil_wrw_iop((void *) (CANC_0_BASE + (mem)), (data))

/* ɼѥ쥸ޥ */
#define CANC_RD_TXCMP_REG()							SIL_REW_IOP_CANC_0_BASE(CANC_TXCMP_REG)
#define CANC_RD_TXABORTCMP_REG()					SIL_REW_IOP_CANC_0_BASE(CANC_TXABORTCMP_REG)
#define CANC_RD_RXWAIT_REG()						SIL_REW_IOP_CANC_0_BASE(CANC_RXWAIT_REG)
#define CANC_RD_RXCMP_REG()							SIL_REW_IOP_CANC_0_BASE(CANC_RXCMP_REG)
#define CANC_RD_RXOVERWRITE_REG()					SIL_REW_IOP_CANC_0_BASE(CANC_RXOVERWRITE_REG)
#define CANC_RD_STATUS_REG()						SIL_REW_IOP_CANC_0_BASE(CANC_STATUS_REG)
#define CANC_RD_IRQ_REG()							SIL_REW_IOP_CANC_0_BASE(CANC_IRQ_REG)
#define CANC_RD_CLKDIV_BUSTIM_REG()					SIL_REW_IOP_CANC_0_BASE(CANC_CLKDIV_BUSTIM_REG)
#define CANC_RD_ERROR_CNT_REG()						SIL_REW_IOP_CANC_0_BASE(CANC_ERROR_CNT_REG)
#define CANC_RD_RXMBOX_DATA0_REG(box_num)			SIL_REW_IOP_CANC_0_BASE((CANC_RXMBOX_DATA0_REG + (0x0010U * (box_num))))
#define CANC_RD_RXMBOX_DATA1_REG(box_num)			SIL_REW_IOP_CANC_0_BASE((CANC_RXMBOX_DATA1_REG + (0x0010U * (box_num))))
#define CANC_RD_RXMBOX_DATA2_REG(box_num)			SIL_REW_IOP_CANC_0_BASE((CANC_RXMBOX_DATA2_REG + (0x0010U * (box_num))))
#define CANC_RD_RXMBOX_DATA3_REG(box_num)			SIL_REW_IOP_CANC_0_BASE((CANC_RXMBOX_DATA3_REG + (0x0010U * (box_num))))

/* ѥ쥸ޥ */
#define CANC_WR_MODE_REG(data)						SIL_WRW_IOP_CANC_0_BASE(CANC_MODE_REG, data)
#define CANC_WR_TXREQ_REG(data)						SIL_WRW_IOP_CANC_0_BASE(CANC_TXREQ_REG, data)
#define CANC_WR_TXABORT_REG(data)					SIL_WRW_IOP_CANC_0_BASE(CANC_TXABORT_REG, data)
#define CANC_WR_TXCMP_REG(data)						SIL_WRW_IOP_CANC_0_BASE(CANC_TXCMP_REG, data)
#define CANC_WR_TXABORTCMP_REG(data)				SIL_WRW_IOP_CANC_0_BASE(CANC_TXABORTCMP_REG, data)
#define CANC_WR_RXWAIT_REG(data)					SIL_WRW_IOP_CANC_0_BASE(CANC_RXWAIT_REG, data)
#define CANC_WR_RXCMP_REG(data)						SIL_WRW_IOP_CANC_0_BASE(CANC_RXCMP_REG, data)
#define CANC_WR_RXSELFREQ_REG(data)					SIL_WRW_IOP_CANC_0_BASE(CANC_RXSELFREQ_REG, data)
#define CANC_WR_IRQ_EN_REG(data)					SIL_WRW_IOP_CANC_0_BASE(CANC_IRQ_EN_REG, data)
#define CANC_WR_IRQ_RXEN_REG(data)					SIL_WRW_IOP_CANC_0_BASE(CANC_IRQ_RXEN_REG, data)
#define CANC_WR_CLKDIV_BUSTIM_REG(data)				SIL_WRW_IOP_CANC_0_BASE(CANC_CLKDIV_BUSTIM_REG, data)
#define CANC_WR_ACCEPTANCE_CODE_REG(data)			SIL_WRW_IOP_CANC_0_BASE(CANC_ACCEPTANCE_CODE_REG, data)
#define CANC_WR_ACCEPTANCE_MASK_REG(data)			SIL_WRW_IOP_CANC_0_BASE(CANC_ACCEPTANCE_MASK_REG, data)
#define CANC_WR_ERROR_CNT_REG(data)					SIL_WRW_IOP_CANC_0_BASE(CANC_ERROR_CNT_REG, data)
#define CANC_WR_MBOXWIN_REG(box_num)				SIL_WRW_IOP_CANC_0_BASE(CANC_MBOXWIN_REG, ((box_num) << 16))
#define CANC_WR_RXMBOX_ACCEPTANCE_CODE_REG(data)	SIL_WRW_IOP_CANC_0_BASE(CANC_RXMBOX_ACCEPTANCE_CODE_REG, data)
#define CANC_WR_RXMBOX_ACCEPTANCE_MASK_REG(data)	SIL_WRW_IOP_CANC_0_BASE(CANC_RXMBOX_ACCEPTANCE_MASK_REG, data)
#define CANC_WR_TXMBOX_DATA0_REG(data, box_num)		SIL_WRW_IOP_CANC_0_BASE((CANC_TXMBOX_DATA0_REG + (0x0010U * (box_num))), data)
#define CANC_WR_TXMBOX_DATA1_REG(data, box_num)		SIL_WRW_IOP_CANC_0_BASE((CANC_TXMBOX_DATA1_REG + (0x0010U * (box_num))), data)
#define CANC_WR_TXMBOX_DATA2_REG(data, box_num)		SIL_WRW_IOP_CANC_0_BASE((CANC_TXMBOX_DATA2_REG + (0x0010U * (box_num))), data)
#define CANC_WR_TXMBOX_DATA3_REG(data, box_num)		SIL_WRW_IOP_CANC_0_BASE((CANC_TXMBOX_DATA3_REG + (0x0010U * (box_num))), data)

#endif /* CAN_NIOS2_H */
