/*
 *  TOPPERS/A-CAN
 *      Automotive CAN
 *
 *  Copyright (C) 2013-2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2013-2014 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2013-2014 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2013-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2013-2014 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2013-2014 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2013-2014 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: os.c 4208 2014-03-13 04:05:21Z shigihara $
 */

#include "Os.h"
#include "Can.h"
#include "t_syslog.h"
#include "prc_sil.h"

#define SW_BASE		0x08000410
#define KEY_BASE	0x08000400
#define KEY_0		0x01
#define KEY_1		0x02
#define KEY_2		0x04
#define KEY_3		0x08

TASK(MainTask){
	volatile uint32 i;
	uint8			Hth;
	uint32			cur_key;
	uint8			sw_state[8] = {0U};
	static uint32	pre_key = 0xFFFF;
	Can_PduType		send_data;

	Can_Init(NULL_PTR);

	Can_SetControllerMode(0U, CAN_T_START);

	syslog(LOG_NOTICE, "");
	syslog(LOG_NOTICE, "== Can_Init ==");
	syslog(LOG_NOTICE, "");

	while (1) {
		cur_key = sil_rew_iop((void *) KEY_BASE);

		*((uint32 *) sw_state) = sil_rew_iop((void *) SW_BASE);
		send_data.length = 8U;
		send_data.sdu = sw_state;

		/* ܥ󲡲֤ܤΤ߽Ԥ */
		if (((pre_key & KEY_0) != 0) && ((cur_key & KEY_0) == 0)) {
			send_data.swPduHandle = 0U;
			send_data.id = 0x02U;
			Hth = 0U;
			syslog(LOG_NOTICE, "[KEY0] Can_Write(%d) CAN-ID:0x%x", Hth, send_data.id);
			for (i = 0U; i < send_data.length; i++) {
				syslog(LOG_NOTICE, "DATA[%d]:0x%x", i, send_data.sdu[i]);
			}
			Can_Write(Hth, &send_data);
			syslog(LOG_NOTICE, "");
		}
		else if (((pre_key & KEY_1) != 0) && ((cur_key & KEY_1) == 0)) {
			send_data.swPduHandle = 1U;
			send_data.id = 0x04U;
			Hth = 2U;
			syslog(LOG_NOTICE, "[KEY1] Can_Write(%d) CAN-ID:0x%x", Hth, send_data.id);
			for (i = 0U; i < send_data.length; i++) {
				syslog(LOG_NOTICE, "DATA[%d]:0x%x", i, send_data.sdu[i]);
			}
			Can_Write(Hth, &send_data);
			syslog(LOG_NOTICE, "");
		}
		else if (((pre_key & KEY_2) != 0) && ((cur_key & KEY_2) == 0)) {
			send_data.swPduHandle = 2U;
			send_data.id = 0x06U;
			Hth = 4U;
			syslog(LOG_NOTICE, "[KEY2] Can_Write(%d) CAN-ID:0x%x", Hth, send_data.id);
			for (i = 0U; i < send_data.length; i++) {
				syslog(LOG_NOTICE, "DATA[%d]:0x%x", i, send_data.sdu[i]);
			}
			Can_Write(Hth, &send_data);
			syslog(LOG_NOTICE, "");
		}
		else if (((pre_key & KEY_3) != 0) && ((cur_key & KEY_3) == 0)) {
			send_data.swPduHandle = 3U;
			send_data.id = 0x08U;
			Hth = 6U;
			syslog(LOG_NOTICE, "[KEY3] Can_Write(%d) CAN-ID:0x%x", Hth, send_data.id);
			for (i = 0U; i < send_data.length; i++) {
				syslog(LOG_NOTICE, "DATA[%d]:0x%x", i, send_data.sdu[i]);
			}
			Can_Write(Hth, &send_data);
			syslog(LOG_NOTICE, "");
		}

		pre_key = cur_key;

		/*  */
		for (i = 0U; i < 100000U; i++) {
		}
	}

	ShutdownOS(E_OK);
}

ProtectionReturnType
ProtectionHook(StatusType FatalError)
{
	syslog(LOG_NOTICE, "## ProtectionHook is called !! (%d)", FatalError);

	return(PRO_SHUTDOWN);
}

sint32
main(void)
{
	StartOS(MainApp);
	while (1) ;
	return(0);
}
