#!ruby -Ke
#
#  TOPPRES/A-CANIF
#      Automotive CANIF
#
#  Copyright (C) 2013-2014 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2013-2014 by FUJISOFT INCORPORATED, JAPAN
#  Copyright (C) 2013-2014 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
#  Copyright (C) 2013-2014 by Renesas Electronics Corporation, JAPAN
#  Copyright (C) 2013-2014 by Sunny Giken Inc., JAPAN
#  Copyright (C) 2013-2014 by TOSHIBA CORPORATION, JAPAN
#  Copyright (C) 2013-2014 by Witz Corporation, JAPAN
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
#  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
#  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
#  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: get_spec_id.rb 4196 2014-03-10 09:35:29Z sunnygiken-matsumoto $
#

#
#  λͥФ
#

if ($0 == __FILE__)
  TOOL_ROOT = File.expand_path(File.dirname(__FILE__) + "/")
  $LOAD_PATH.unshift(TOOL_ROOT)
end

require "pp"

# оݥե
aTargetFiles = []
aTargetFiles.push("#{TOOL_ROOT}/../../CanIf.c")
aTargetFiles.push("#{TOOL_ROOT}/../../CanIf.h")
aTargetFiles.push("#{TOOL_ROOT}/../../CanIf_Types.h")
aTargetFiles.push("#{TOOL_ROOT}/../../canif.tf")

# NCANIFͽ
aNCANIFSpecFiles = []
aNCANIFSpecFiles.push("#{TOOL_ROOT}/../../doc/canif_spec.txt")
aNCANIFSpecFiles.push("#{TOOL_ROOT}/../../doc/canif_container.txt")
aNCANIFSpecFiles.push("#{TOOL_ROOT}/../../doc/canif_system_service.txt")

# оݥɽ
sTagRegNcanif = "NCANIF[0-9][0-9][0-9]"
sTagRegCanIfA = "CANIFa[0-9][0-9][0-9]"
sTagRegCanIf = "CANIFa?[0-9][0-9][0-9][_Conf]*"
sTagRegAll = "N?#{sTagRegCanIf}"

#
# NCANIFCANIFaͼ
#
aSpecData = []
aNCANIFSpecFiles.each{|sFileName|
  sFileData = File.read(sFileName)
  # ԥɤѴ
  if (sFileData.include?("\r\n"))
    sFileData.gsub!("\r\n","\n")
  end
  if (sFileData.include?("\r"))
    sFileData.gsub!("\r","\n")
  end

  aTmpData = sFileData.split("\n")

  # [1ΥɡԿե̾]ΥåȤݻ
  nLine = 1
  aTmpData.each{|sLine|
    aSpecData.push([sLine, nLine, File.basename(sFileName)])
    nLine += 1
  }
}

# 
hNcanifSpecInfo = {}

aSpecData.each{|aLine|
  # ͥ¸ߤʤϲ⤷ʤ
  if ((aLine[0] !~ /\[#{sTagRegNcanif}\]/) && (aLine[0] !~ /\[#{sTagRegCanIfA}\]/))
    next
  end

  aTags = []
  # 1Ԥ˴ޤޤ뤹٤Ƥλͥ
  aTags.concat(aLine[0].scan(/\[#{sTagRegNcanif}\]/))
  aTags.concat(aLine[0].scan(/\[#{sTagRegCanIfA}\]/))

  aTags.each{|sTag|
    if (!hNcanifSpecInfo.has_key?(sTag))
      hNcanifSpecInfo[sTag] = []
    end
    hNcanifSpecInfo[sTag].push("#{aLine[2]}:#{aLine[1]}")
  }
}

# IDǥȤƷ̤
aTagID = hNcanifSpecInfo.keys()
aTagID.sort!()
sResult = ""
aTagID.each{|sTag|
  sPlace = ""
  hNcanifSpecInfo[sTag].each{|sLine|
    sPlace += "#{sLine}, "
  }
  sPlace.chop!().chop!()

  sResult += "#{sTag} @ #{sPlace}\n"
}

# եؽϤ
File.open("#{TOOL_ROOT}/nces_spec_id.txt", "w") {|io|
  io.puts(sResult)
}

# оݻͤоݻͤνʣå
aNcanifSpec = []
aCanIfASpec = []
aTagID.each{|sTag|
  # NCANIF
  if (sTag =~ /\[#{sTagRegNcanif}\]/)
    aNcanifSpec.push(sTag.gsub(/\[(#{sTagRegAll})\]/, "\\1"))
  # CANIFa
  elsif (sTag =~ /\[#{sTagRegCanIfA}\]/)
    aCanIfASpec.push(sTag.gsub(/\[(#{sTagRegCanIfA})\]/, "\\1"))
  else
    abort("Error!!")
  end
}



#
# ɼ
#
aCodeData = []
aTargetFiles.each{|sFileName|
  sFileData = File.read(sFileName)
  # ԥɤѴ
  if (sFileData.include?("\r\n"))
    sFileData.gsub!("\r\n","\n")
  end
  if (sFileData.include?("\r"))
    sFileData.gsub!("\r","\n")
  end

  aTmpData = sFileData.split("\n")

  # [1ΥɡԿե̾]ΥåȤݻ
  nLine = 1
  aTmpData.each{|sLine|
    aCodeData.push([sLine, nLine, File.basename(sFileName)])
    nLine += 1
  }
}

# 
hSpecInfo = {}

aCodeData.each{|aLine|
  # ͥ¸ߤʤϲ⤷ʤ
  if (aLine[0] !~ /[\[<]#{sTagRegAll}[\]>]/)
    next
  end

  aTags = []
  # 1Ԥ˴ޤޤ뤹٤Ƥλͥ
  aTags.concat(aLine[0].scan(/[\[<]#{sTagRegAll}[\]>]/))

  aTags.each{|sTag|
    if (!hSpecInfo.has_key?(sTag))
      hSpecInfo[sTag] = []
    end
    hSpecInfo[sTag].push("#{aLine[2]}:#{aLine[1]}")
  }
}

# IDǥȤƷ̤
aTagID = hSpecInfo.keys()
aTagID.sort!()
sResult = ""
aTagID.each{|sTag|
  sPlace = ""
  hSpecInfo[sTag].each{|sLine|
    sPlace += "#{sLine}, "
  }
  sPlace.chop!().chop!()

  sResult += "#{sTag} @ #{sPlace}\n"
}

# եؽϤ
File.open("#{TOOL_ROOT}/impl_spec_id.txt", "w") {|io|
  io.puts(sResult)
}

# оݻͤоݻͤνʣå
nAutosarCnt = 0
aTargetSpec = []
aNonTargetSpec = []
aImplCanIfASpec = []
aImplNcanifSpec = []
aTagID.each{|sTag|
  # CANIFa
  if (sTag =~ /\[#{sTagRegCanIfA}\]/)
    aImplCanIfASpec.push(sTag.gsub(/\[(#{sTagRegCanIfA})\]/, "\\1"))
  # NCANIF
  elsif (sTag =~ /\[#{sTagRegNcanif}\]/)
    aImplNcanifSpec.push(sTag.gsub(/\[(#{sTagRegAll})\]/, "\\1"))
  # оݻ
  elsif (sTag =~ /\[#{sTagRegCanIf}\]/)
    aTargetSpec.push(sTag.gsub(/\[(#{sTagRegCanIf})\]/, "\\1"))
    nAutosarCnt += 1
  # оݻ
  elsif (sTag =~ /<#{sTagRegCanIf}>/)
    aNonTargetSpec.push(sTag.gsub(/<(#{sTagRegCanIf})>/, "\\1"))
    nAutosarCnt += 1
  else
    abort("Error!!")
  end
}

# ݡо/оݤηɽ
puts("=" * 35)
puts("AUTOSAR tags         : #{aTargetSpec.size() + aNonTargetSpec.size()}")
puts("-" * 35)
fRatio = aTargetSpec.size().to_f() / nAutosarCnt * 100
puts("For support tags     : #{aTargetSpec.size()} (#{sprintf('%0.1f', fRatio)}%)")
fRatio = aNonTargetSpec.size().to_f() / nAutosarCnt * 100
puts("For non-support tags : #{aNonTargetSpec.size()} (#{sprintf('%0.1f', fRatio)}%)")
puts("=" * 35)

# ʣɽ
aTargetSpec.each{|sTarget|
  if (aNonTargetSpec.include?(sTarget))
    puts("#{sTarget} is conflicted !!")
    pp hSpecInfo["[#{sTarget}]"]
    pp hSpecInfo["<#{sTarget}>"]
  end
}

# ȼηɽ
puts("=" * 35)
puts("NCANIF tags     : #{aNcanifSpec.size()}")
puts("Implemented tags: #{aImplNcanifSpec.size()}")
fCoverage = aImplNcanifSpec.size().to_f() / aNcanifSpec.size().to_f() * 100
puts("NCANIF Coverage : #{sprintf('%0.1f', fCoverage)} %")
puts("-" * 35)
puts("CANIFa tags     : #{aCanIfASpec.size()}")
puts("Implemented tags: #{aImplCanIfASpec.size()}")
fCoverage = aImplCanIfASpec.size().to_f() / aCanIfASpec.size().to_f() * 100
puts("CANIFa Coverage : #{sprintf('%0.1f', fCoverage)} %")
puts("=" * 35)

# Ƥʤɽ
aNcanifSpec.each{|sTag|
  if (!aImplNcanifSpec.include?(sTag))
    puts(sTag)
  end
}
aCanIfASpec.each{|sTag|
  if (!aImplCanIfASpec.include?(sTag))
    puts(sTag)
  end
}

